> This is a page from the ElevenLabs documentation. For a complete page index, fetch https://elevenlabs.io/docs/llms.txt. For the full documentation in a single file, fetch https://elevenlabs.io/docs/llms-full.txt.

# Upload Knowledge Source

POST https://api.elevenlabs.io/v1/reception/knowledge-sources
Content-Type: multipart/form-data

Upload a file as a knowledge source

Reference: https://elevenlabs.io/docs/api-reference/reception/knowledge-sources/upload

## Servers

- `https://api.elevenlabs.io` (Production, default)
- `https://api.us.elevenlabs.io` (Production US)
- `https://api.eu.residency.elevenlabs.io` (Production EU)
- `https://api.in.residency.elevenlabs.io` (Production India)
- `https://api.sg.residency.elevenlabs.io` (Production Singapore)

## Request

### Headers

- `xi-workspace-id` (string, optional, nullable) — The customer workspace a reseller's API key acts on.

### Body (multipart/form-data)

This endpoint expects a multipart form containing a file.

- `file` (file, required)

## Response

### 200

Respuesta correcta.

- `_id` (string, required)
- `source_type` (enum, optional, default: file) — Type of knowledge source.
  - Allowed values: `file`, `url`
- `source_url` (string, optional, nullable)
- `last_scraped_at_unix` (integer, optional, nullable)
- `original_filename` (string, optional, default: )
- `content_type` (string, optional, default: )
- `file_size_bytes` (integer, optional, default: 0)
- `status` (enum, optional, default: processing) — Processing status for knowledge sources. - `processing`: the file or site is being read. - `ready`: done; the results are available. - `error`: it failed and can be retried. See `progress` for detail.
  - Allowed values: `processing`, `ready`, `error`
- `error_message` (string, optional, nullable)
- `failure_reason` (enum, optional, nullable) — Why processing a knowledge source failed.
  - Allowed values: `blocked_url`, `dns_failure`, `host_unreachable`, `access_refused`, `crawl_timeout`, `no_pages`, `no_content`, `upstream_timeout`, `upstream_error`, `unknown`
- `crawl_entire_site` (boolean, optional, default: false)
- `scraped_pages_count` (integer, optional, default: 0)
- `content_preview` (string, optional, nullable)
- `processing_started_at_unix` (integer, optional, nullable)
- `created_at_unix` (integer, optional) — Unix timestamp (seconds since epoch)
- `updated_at_unix` (integer, optional) — Unix timestamp (seconds since epoch)

## Errors

### 422 Unprocessable Entity Error

Error de validación

- `detail` (list of ValidationError, optional)

## Types

### ValidationError

- `loc` (list of ValidationErrorLocItems, required)
- `msg` (string, required)
- `type` (string, required)

### ValidationErrorLocItems

- string
- integer

## Examples

**Request**

```json
{
  "file": "<file: string>"
}
```

**Response**

```json
{
  "_id": "string",
  "source_type": "file",
  "source_url": "string",
  "last_scraped_at_unix": 1,
  "original_filename": "",
  "content_type": "",
  "file_size_bytes": 0,
  "status": "processing",
  "error_message": "string",
  "failure_reason": "blocked_url",
  "crawl_entire_site": false,
  "scraped_pages_count": 0,
  "content_preview": "string",
  "processing_started_at_unix": 1,
  "created_at_unix": 1,
  "updated_at_unix": 1
}
```

**SDK Code**

```python
import requests

url = "https://api.elevenlabs.io/v1/reception/knowledge-sources"

files = { "file": "open('string', 'rb')" }

response = requests.post(url, files=files)

print(response.json())
```

```javascript
const url = 'https://api.elevenlabs.io/v1/reception/knowledge-sources';
const form = new FormData();
form.append('file', 'string');

const options = {method: 'POST'};

options.body = form;

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.elevenlabs.io/v1/reception/knowledge-sources"

	payload := strings.NewReader("-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"file\"; filename=\"string\"\r\nContent-Type: application/octet-stream\r\n\r\n\r\n-----011000010111000001101001--\r\n")

	req, _ := http.NewRequest("POST", url, payload)

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.elevenlabs.io/v1/reception/knowledge-sources")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request.body = "-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"file\"; filename=\"string\"\r\nContent-Type: application/octet-stream\r\n\r\n\r\n-----011000010111000001101001--\r\n"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.elevenlabs.io/v1/reception/knowledge-sources")
  .body("-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"file\"; filename=\"string\"\r\nContent-Type: application/octet-stream\r\n\r\n\r\n-----011000010111000001101001--\r\n")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.elevenlabs.io/v1/reception/knowledge-sources', [
  'multipart' => [
    [
        'name' => 'file',
        'filename' => 'string',
        'contents' => null
    ]
  ]
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.elevenlabs.io/v1/reception/knowledge-sources");
var request = new RestRequest(Method.POST);
request.AddParameter("undefined", "-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"file\"; filename=\"string\"\r\nContent-Type: application/octet-stream\r\n\r\n\r\n-----011000010111000001101001--\r\n", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation
let parameters = [
  [
    "name": "file",
    "fileName": "string"
  ]
]

let boundary = "---011000010111000001101001"

var body = ""
var error: NSError? = nil
for param in parameters {
  let paramName = param["name"]!
  body += "--\(boundary)\r\n"
  body += "Content-Disposition:form-data; name=\"\(paramName)\""
  if let filename = param["fileName"] {
    let contentType = param["content-type"]!
    let fileContent = String(contentsOfFile: filename, encoding: String.Encoding.utf8)
    if (error != nil) {
      print(error as Any)
    }
    body += "; filename=\"\(filename)\"\r\n"
    body += "Content-Type: \(contentType)\r\n\r\n"
    body += fileContent
  } else if let paramValue = param["value"] {
    body += "\r\n\r\n\(paramValue)"
  }
}

let request = NSMutableURLRequest(url: NSURL(string: "https://api.elevenlabs.io/v1/reception/knowledge-sources")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```